program opiela19;

{$mode objfpc}{$H+}

uses
  {$IFDEF UNIX}{$IFDEF UseCThreads}
  cthreads,
  {$ENDIF}{$ENDIF}
  Classes
  { you can add units after this },
  crt;

{$R *.res}

type ukazovatel=^zaznam;
     zaznam=record
       hodnota:integer;
       dalsi:ukazovatel;
       predchodca:ukazovatel;
     end;

var start:ukazovatel;
    z:char;
    i,n,x:integer;

procedure PridajNaZaciatok(hodnota:integer);
var p:ukazovatel;
begin
  new(p);
  p^.hodnota:=hodnota;
  if start=nil
     then begin
            p^.dalsi:=p;
            p^.predchodca:=p;
          end
     else begin
            p^.dalsi:=start;
            p^.predchodca:=start^.predchodca;
            start^.predchodca^.dalsi:=p;
            start^.predchodca:=p;
          end;
  start:=p;
end;

procedure PridajNaKoniec(hodnota:integer);
var p:ukazovatel;
begin
  new(p); {dispose(p) - zrusi ukazovatel}
  p^.hodnota:=hodnota;
  if start=nil
     then begin
            p^.dalsi:=p;
            p^.predchodca:=p;
            start:=p;
          end
     else begin
            p^.dalsi:=start;
            p^.predchodca:=start^.predchodca;
            start^.predchodca^.dalsi:=p;
            start^.predchodca:=p;
          end;
end;

procedure OdoberZaciatok;
begin
  if start=nil
     then Writeln('Zoznam je prazdny.')
     else if start^.dalsi=start
             then begin
                    Writeln('Odobrana hodnota ',start^.hodnota);
                    start:=nil;
                  end
             else begin
                    Writeln('Odobrana hodnota ',start^.hodnota);
                    start^.dalsi^.predchodca:=start^.predchodca;
                    start^.predchodca^.dalsi:=start^.dalsi;
                    start:=start^.dalsi;
                  end;
end;

procedure OdoberKoniec;
var p:ukazovatel;
begin
  if start=nil
     then Writeln('Zoznam je prazdny.')
     else begin
            p:=start^.predchodca;
            if start^.dalsi=start
               then begin
                      Writeln('Odobrana hodnota ',p^.hodnota);
                      start:=nil;
                    end
               else begin
                      Writeln('Odobrana hodnota ',p^.hodnota);
                      p^.predchodca^.dalsi:=start;
                      start^.predchodca:=p^.predchodca;
                    end;
          end;
end;

procedure Odober(x:integer);
var p:ukazovatel;
    zmeny:boolean;
begin
  repeat
  zmeny:=false;
  if start=nil
     then Writeln('Zoznam je prazdny. ')
     else if start^.dalsi=start
             then begin
                    if start^.hodnota=x
                       then begin
                              Writeln('Hodnota ',x,' bola odstranena.');
                              zmeny:=true;
                              start:=nil
                            end;
                  end
             else begin
                    p:=start^.predchodca;
                    repeat
                      p:=p^.dalsi;
                    until (p^.hodnota=x) or (p=start^.predchodca);
                    if p^.hodnota=x
                       then begin
                              Writeln('Hodnota ',x,' bola odstranena.');
                              zmeny:=true;
                              p^.predchodca^.dalsi:=p^.dalsi;
                              p^.dalsi^.predchodca:=p^.predchodca;
                              if p=start then start:=start^.dalsi;
                            end;
                  end;
  until zmeny=false;
  if zmeny=false then Writeln('Hodnota ',x,' sa v zozname nenachadza.');
end;

procedure TriedenieVymenou;
var i,j:ukazovatel;
    pom:integer;
begin
  i:=start^.dalsi;
  repeat
    j:=start^.predchodca;
    repeat
    if j^.predchodca^.hodnota>j^.hodnota
       then begin
              pom:=j^.predchodca^.hodnota;
              j^.predchodca^.hodnota:=j^.hodnota;
              j^.hodnota:=pom;
            end;
            j:=j^.predchodca;
    until j=i^.predchodca;
    i:=i^.dalsi;
  until i=start;
end;

procedure PridanieDoUtriedeneho(hodnota:integer);
var p,q:ukazovatel;
begin
  new(p);
  p^.hodnota:=hodnota;
  if start=nil
     then begin
            p^.dalsi:=p;
            p^.predchodca:=p;
            start:=p;
          end
     else begin
            q:=start;
            repeat
              q:=q^.dalsi;
            until (q^.hodnota>p^.hodnota) or (q=start);
            if start^.hodnota>p^.hodnota then q:=q^.predchodca;
            p^.dalsi:=q;
            p^.predchodca:=q^.predchodca;
            q^.predchodca^.dalsi:=p;
            q^.predchodca:=p;
            if (q=start) and (start^.hodnota>p^.hodnota) then start:=p;
          end;
end;

procedure VypisZoznam;
var p:ukazovatel;
begin
  if start=nil
     then Writeln('Zoznam je prazdny.')
     else begin
            p:=start;
            repeat
              Write(p^.hodnota,' ');
              p:=p^.dalsi;
            until p=start;
          end;
end;

procedure menu;
begin
  Writeln('Vitajte v programe pre pracu s dynamickymi datovymi strukturami.');
  Writeln('a) Vypis cely zoznam.');
  Writeln('b) Pridaj na zaciatok.');
  Writeln('c) Pridaj na koniec.');
  Writeln('d) Odober zo zaciatku.');
  Writeln('e) Odober z konca.');
  Writeln('f) Odstranenie konkretnej hodnoty. (Odstrani vsetky vyskyty danej hodnoty)');
  Writeln('g) Usporiadanie zoznamu. (Vzostupne)');
  Writeln('h) Pridanie do usporiadaneho zoznamu. (Najprv usporiada)');
  Writeln('i) Zmaz cely zoznam.');
  Writeln('q) Koniec.');
  Writeln('Zadajte pismeno ulohy, ktoru mam vykonat:');
  Writeln('-----------------------------------------');
end;

begin
  start:=nil;
  repeat
    ClrScr;
    menu;
    z:=readkey;
    case z of
    'a': begin
           if start=nil
              then Writeln('Zoznam je prazdny.')
              else begin
                     Writeln('Zoznam:');
                     VypisZoznam;
                   end;
           Readln;
         end;
    'b': begin
           Write('Kolko prvkov chcete pridat? ');
           Readln(n);
           for i:=1 to n do
            begin
             Write('Zadajte cislo, ktore chcete pridat na zaciatok: ');
             Readln(x);
             PridajNaZaciatok(x);
            end;
           Writeln('Pridane na zaciatok.');
           Readln;
         end;
    'c': begin
           Write('Kolko prvkov chcete pridat? ');
           Readln(n);
           for i:=1 to n do
            begin
             Write('Zadajte cislo, ktore chcete pridat na koniec: ');
             Readln(x);
             PridajNaKoniec(x);
            end;
           Writeln('Pridane na koniec.');
           Readln;
         end;
    'd': begin
           Write('Kolko prvkov chcete odobrat? ');
           Readln(n);
           for i:=1 to n do
             begin
               if start=nil
                  then begin
                         Writeln('Zoznam je prazdny.');
                         break;
                       end;
               OdoberZaciatok;
             end;
           Readln;
         end;
    'e': begin
           Write('Kolko prvkov chcete odobrat? ');
           Readln(n);
           for i:=1 to n do
             begin
               if start=nil
                  then begin
                         Writeln('Zoznam je prazdny.');
                         break;
                       end;
               OdoberKoniec;
             end;
           Readln;
         end;
    'f': begin
           Write('Aku hodnotu ma prvok, ktory chcete odstranit? ');
           Readln(x);
           Odober(x);
           Readln;
         end;
    'g': begin
           if start=nil
              then Writeln('Zoznam je prazdny.')
              else begin
                     TriedenieVymenou;
                     Writeln('Uspesne utriedene :) ');
                     VypisZoznam;
                   end;
           Readln;
         end;
    'h': begin
           if start<>nil then TriedenieVymenou;
           Write('Zadajte cislo, ktore chcete pridat do utriedeneho zoznamu: ');
           Readln(x);
           PridanieDoUtriedeneho(x);
           Writeln('Hodnota ',x,' bola pridana do utriedeneho zoznamu.');
           VypisZoznam;
           Readln;
         end;
    'i': begin
           start:=nil;
           Writeln('Zoznam je zmazany.');
           Readln;
         end;
    end;
  until z='q';
end.

